if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[dbfimportsetup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[dbfimportsetup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[max_ids]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[max_ids]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_doma]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[sp_doma]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_gni_street]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[sp_gni_street]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_kladr]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[sp_kladr]
GO

CREATE TABLE [dbo].[dbfimportsetup] (
	[spid] [varchar] (15)  NOT NULL ,
	[dbname] [varchar] (60)  NOT NULL ,
	[dbfname] [varchar] (60)  NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[max_ids] (
	[table_name] [char] (30)  NOT NULL ,
	[max_id] [decimal](16, 0) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[sp_doma] (
	[key_f] [varchar] (15)  NOT NULL ,
	[s_name] [varchar] (80)  NULL ,
	[s_korp] [varchar] (20)  NULL ,
	[s_socr] [varchar] (20)  NULL ,
	[s_code] [varchar] (38)  NULL ,
	[s_index] [varchar] (12)  NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[sp_gni_street] (
	[key_f] [varchar] (10)  NOT NULL ,
	[s_name] [varchar] (40)  NULL ,
	[s_socr] [varchar] (10)  NULL ,
	[s_code] [varchar] (15)  NULL ,
	[s_index] [varchar] (6)  NULL ,
	[s_gninmb] [varchar] (4)  NULL ,
	[s_ocatd] [varchar] (11)  NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[sp_kladr] (
	[key_f] [varchar] (15)  NOT NULL ,
	[s_name] [varchar] (40)  NULL ,
	[s_socr] [varchar] (10)  NULL ,
	[s_code] [varchar] (11)  NULL ,
	[s_index] [varchar] (6)  NULL ,
	[s_gninmb] [varchar] (4)  NULL ,
	[s_ocatd] [varchar] (11)  NULL ,
	[s_syscod] [varchar] (10)  NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[dbfimportsetup] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[spid],
		[dbname]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[sp_doma] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[key_f]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[sp_gni_street] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[key_f]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[sp_kladr] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[key_f]
	)  ON [PRIMARY] 
GO

insert into max_ids (table_name, max_id) values('sp_gni_street', 0)
insert into max_ids (table_name, max_id) values('sp_kladr', 0)
insert into max_ids (table_name, max_id) values('sp_doma', 0)

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_check_dom2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_check_dom2]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE procedure dbo.sp_check_dom2 @gni_code varchar (15), @dom_nomer varchar(15), @s_index varchar (12) OUTPUT AS
declare @ls_name varchar(80), @li_pos1 integer, @li_pos2 integer, @ls_tmp varchar(30), @ls_dom varchar (80), 
	@li_pos3 integer, @li_start_dom integer, @li_end_dom integer, @ls_index varchar (12), @ls_insert_dom varchar (10),
	@li_len_name integer, @cmd sysname, @li_index integer, @li_dom_nomer int, @ls_row_name varchar (80)

DECLARE Check_Cursor CURSOR STATIC FOR
select s_name, s_index from ait_hr_gni..sp_doma where left(s_code,15) = @gni_code
OPEN Check_Cursor 

FETCH NEXT FROM Check_Cursor 
into @ls_row_name, @ls_index
WHILE @@FETCH_STATUS = 0
begin
	select @ls_name = ltrim(rtrim(@ls_row_name))
	select @li_len_name = len(@ls_name)
	WHILE @li_len_name > 0
	BEGIN
		select @li_pos1 = PATINDEX ( '%,%' , @ls_name ) 
		if @li_pos1 > 0 
		begin
			select @ls_dom = left(@ls_name, @li_pos1 - 1)
			select @ls_name = right(@ls_name, LEN ( @ls_name ) - @li_pos1)--   1  
		end
		else
		begin
			select @ls_dom = @ls_name
			select @ls_name = ''
		end
		if isnumeric(@dom_nomer) = 1
		begin
			select @li_dom_nomer = convert(integer, @dom_nomer)

			IF  (PATINDEX ( '%(%' , @ls_dom ))  > 0--  (1-10)(2-12)
			BEGIN
				select @li_pos2 = PATINDEX ( '%(%' , @ls_dom )
				select @li_pos3 = PATINDEX ( '%-%' , @ls_dom )
				select @li_start_dom = Convert(integer, SUBSTRING ( @ls_dom , @li_pos2 + 1 , @li_pos3 - @li_pos2 - 1 ))
				select @li_end_dom = Convert(integer, SUBSTRING ( @ls_dom , @li_pos3 + 1 , LEN ( @ls_dom ) - @li_pos3 - 1 ))
				if round(((@li_dom_nomer + @li_start_dom)/2.0), 2) = ((@li_dom_nomer + @li_start_dom)/2)
				Begin
					if @li_dom_nomer >= @li_start_dom and @li_dom_nomer <= @li_end_dom
					begin
						select @s_index = @ls_index
						CLOSE Check_Cursor 
						DEALLOCATE Check_Cursor
						return
					end
				end
				else
				begin
					select @li_pos2 = 0
					select @li_pos3 = 0
					select @li_len_name = len(@ls_name)
					continue
				end

			end
			else
			if ( PATINDEX ( '%-%' , @ls_dom )) > 0--  1-20
			begin
				select @li_pos2 = PATINDEX ( '%-%' , @ls_dom )
				select @li_start_dom = Convert(integer, Left( @ls_dom , @li_pos2 -1 ))
				select @li_end_dom = Convert(integer, SUBSTRING ( @ls_dom , @li_pos2 + 1 , LEN ( @ls_dom ) - @li_pos2  ))
				if round(((@li_dom_nomer + @li_start_dom)/2.0), 2) = ((@li_dom_nomer + @li_start_dom)/2)
				begin
					if @li_dom_nomer >= @li_start_dom and @li_dom_nomer <= @li_end_dom
					begin
						select @s_index = @ls_index
						CLOSE Check_Cursor 
						DEALLOCATE Check_Cursor
						return
					end
				end
				else
				begin
					select @li_pos2 = 0
					select @li_pos3 = 0
					select @li_len_name = len(@ls_name)
					continue
				end
			end
		end
		--     
		If @dom_nomer = @ls_dom
		begin
			select @s_index = @ls_index
			CLOSE Check_Cursor 
			DEALLOCATE Check_Cursor
			return
		end
		select @li_pos2 = 0
		select @li_pos3 = 0
		select @li_len_name = len(@ls_name)
	END
  FETCH NEXT FROM Check_Cursor 
  into @ls_row_name, @ls_index
END

CLOSE Check_Cursor 
DEALLOCATE Check_Cursor


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


